package guest;
import javax.ejb.Singleton;
import javax.ejb.LocalBean;
import javax.ejb.Startup;
import javax.annotation.PreDestroy;
import javax.annotation.PostConstruct;

import javax.persistence.PersistenceContext;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import java.util.Map;

@Singleton
@LocalBean
@Startup
public class ResourceManagerBean {
   
   
    @PersistenceContext(unitName = "guest-pu")
    private EntityManager em;
    private EntityManagerFactory emf;

    public ResourceManagerBean() {
    }
	
	@PostConstruct
	public void initEMF() {
		emf = em.getEntityManagerFactory();
		Map<String,Object> properties = emf.getProperties();
		for( String key : properties.keySet() )
			System.out.println( key + " : " + properties.get( key ) );
	}

    @PreDestroy
    public void closeEMF() {
	/*
		javax.persistence.EntityTransaction et = em.getTransaction();
		if( et.isActive() ) {
			System.out.println( "em is active" );
			et.commit();
		}
		
		if ( emf.isOpen() ) {
			System.out.println( "EMF is open" );
			// emf.close();
		}
		
        if ( em.getEntityManagerFactory() == emf ) {
			System.out.println( "same EMF" );
		} else {
			System.out.println( "different EMF" );
		}
		*/
    }
}
